      SUBROUTINE xginit(number,name1,name2,name3,name4,
     +                   name5,name6,thetime)
****************************************************************
*  Subroutine XGINIT initializes the XGrafiX package.
****************************************************************

*     Global Symbols:
        COMMON /labels/ labindex, plottype(100),
     +                  state(100), title(100),
     +                  xlabel(100), ylabel(100)
        INTEGER labindex
        CHARACTER*(80) plottype, state, title, xlabel, ylabel

*     Input Arguments:
        INTEGER number
        DOUBLE PRECISION thetime
        CHARACTER*(*) name1, name2,name3, name4, name5, name6

*     Externals:
        EXTERNAL strlennb
        INTEGER strlennb

*     Local Symbols:
        INTEGER lenname
        CHARACTER*(80) name1p, name2p, name3p, name4p, name5p,
     +                 name6p

****************************************************************

*     Initialize the label index counter.
      labindex = 0

*     Convert the input FORTRAN strings to C strings.
      lenname = STRLENNB(name1)
      name1p = name1(1:lenname) // char(0)
      lenname = STRLENNB(name2)
      name2p = name2(1:lenname) // char(0)
      lenname = STRLENNB(name3)
      name3p = name3(1:lenname) // char(0)
      lenname = STRLENNB(name4)
      name4p = name4(1:lenname) // char(0)
      lenname = STRLENNB(name5)
      name5p = name5(1:lenname) // char(0)
      lenname = STRLENNB(name6)
      name6p = name6(1:lenname) // char(0)

      CALL initxg(number,name1p,name2p,name3p,name4p,
     +             name5p,name6p,thetime)

      RETURN
      END
*
      SUBROUTINE xgevent
****************************************************************
*  Subroutine XGEVENT checks the control panel status.
****************************************************************

      CALL eventxg

      RETURN
      END
*
      SUBROUTINE xgupdate
****************************************************************
*  Subroutine XGUPDATE refreshes the screen and
*  checks for events.
****************************************************************

      CALL updatexg

      RETURN
      END
*
      SUBROUTINE xgset2d(pt,xl,tl,ws,wulx,wuly,xscale,yscale,
     +                   xauto,yauto,xmin,xmax,ymin,ymax)
****************************************************************
*  Subroutine XGSET2D sets up the information for the
*  initialization of a 2-D (X-Y) line or scatter plot
*  under XGrafiX.
****************************************************************

*     Global Symbols:
        COMMON /labels/ labindex, plottype(100),
     +                  state(100), title(100),
     +                  xlabel(100), ylabel(100)
        INTEGER labindex
        CHARACTER*(80) plottype, state, title, xlabel, ylabel

*     Input Arguments:
        INTEGER wulx, wuly, xauto, yauto
        REAL xmax, xmin, xscale, ymax, ymin, yscale
        CHARACTER*(*) pt, tl, ws, xl

****************************************************************

*     Convert the input FORTRAN strings to C strings.
      labindex           = labindex + 1
      IF (labindex .GT. 100) THEN
        WRITE(6,1000)
 1000   FORMAT("Number of initialized windows exceeds ",
     +         "established allocation!")
        STOP
      ENDIF
      plottype(labindex) = pt // char(0)
      state(labindex)    = ws // char(0)
      title(labindex)    = tl // char(0)
      xlabel(labindex)   = xl // char(0)

      CALL set2dxg(plottype(labindex),xlabel(labindex),
     +             title(labindex),state(labindex),
     +             wulx,wuly,xscale,yscale,xauto,yauto,
     +             xmin,xmax,ymin,ymax)

      RETURN
      END
*
      SUBROUTINE xgset2dc(pt,xl,yl,tl,ws,wulx,wuly,xscale,
     +                    yscale,zscale,xauto,yauto,zauto,
     +                    xmin,xmax,ymin,ymax,zmin,zmax)
****************************************************************
*  Subroutine XGSET2DC sets up the information for the
*  initialization of a 2-D contour plot under XGrafiX.
****************************************************************

*     Global Symbols:
        COMMON /labels/ labindex, plottype(100),
     +                  state(100), title(100),
     +                  xlabel(100), ylabel(100)
        INTEGER labindex
        CHARACTER*(80) plottype, state, title, xlabel, ylabel

*     Input Arguments:
        INTEGER wulx, wuly, xauto, yauto, zauto
        REAL xmax, xmin, xscale, ymax, ymin, yscale
        REAL zmax, zmin, zscale
        CHARACTER*(*) pt, tl, ws, xl, yl

****************************************************************

*     Convert the input FORTRAN strings to C strings.
      labindex           = labindex + 1
      IF (labindex .GT. 100) THEN
        WRITE(6,1000)
 1000   FORMAT("Number of initialized windows exceeds ",
     +         "established allocation!")
        STOP
      ENDIF
      plottype(labindex) = pt // char(0)
      state(labindex)    = ws // char(0)
      title(labindex)    = tl // char(0)
      xlabel(labindex)   = xl // char(0)
      ylabel(labindex)   = yl // char(0)

      CALL set2dcxg(plottype(labindex),xlabel(labindex),
     +              ylabel(labindex),title(labindex),
     +              state(labindex),wulx,wuly,xscale,
     +              yscale,zscale,xauto,yauto,zauto,
     +              xmin,xmax,ymin,ymax,zmin,zmax)

      RETURN
      END
*
      SUBROUTINE xgset3d(pt,xl,yl,tl,theta,phi,ws,wulx,wuly,
     +                   xscale,yscale,zscale,xauto,yauto,zauto,
     +                   xmin,xmax,ymin,ymax,zmin,zmax)
****************************************************************
*  Subroutine XGSET3D sets up the information for the
*  initialization of a 3-D surface or scatter plot
*  under XGrafiX.
****************************************************************

*     Global Symbols:
        COMMON /labels/ labindex, plottype(100),
     +                  state(100), title(100),
     +                  xlabel(100), ylabel(100)
        INTEGER labindex
        CHARACTER*(80) plottype, state, title, xlabel, ylabel

*     Input Arguments:
        INTEGER wulx, wuly, xauto, yauto, zauto
        REAL phi, theta, xmax, xmin, xscale
        REAL ymax, ymin, yscale, zmax, zmin, zscale
        CHARACTER*(*) pt, tl, ws, xl, yl

****************************************************************

*     Convert the input FORTRAN strings to C strings.
      labindex           = labindex + 1
      IF (labindex .GT. 100) THEN
        WRITE(6,1000)
 1000   FORMAT("Number of initialized windows exceeds ",
     +         "established allocation!")
        STOP
      ENDIF
      plottype(labindex) = pt // char(0)
      state(labindex)    = ws // char(0)
      title(labindex)    = tl // char(0)
      xlabel(labindex)   = xl // char(0)
      ylabel(labindex)   = yl // char(0)

      CALL set3dxg(plottype(labindex),xlabel(labindex),
     +             ylabel(labindex),title(labindex),
     +             theta,phi,state(labindex),wulx,wuly,
     +             xscale,yscale,zscale,xauto,yauto,
     +             zauto,xmin,xmax,ymin,ymax,zmin,zmax)

      RETURN
      END
*
      SUBROUTINE xgcurve(xplot,yplot,nx,color)
****************************************************************
*  Subroutine XGCURVE adds an X-Y line plot to the
*  previously initialized window under XGrafiX.
****************************************************************
      
*     Input Arguments:
        INTEGER color, nx
        REAL xplot(*), yplot(*)
      
****************************************************************

      CALL curvexg(xplot,yplot,nx,color)

      RETURN
      END
*
      SUBROUTINE xgscat2d(xplot,yplot,nx,color)
****************************************************************
*  Subroutine XGSCAT2D adds an X-Y scatter plot to the
*  previously initialized window under XGrafiX.
****************************************************************
      
*     Input Arguments:
        INTEGER color, nx
        REAL xplot(*), yplot(*)
      
****************************************************************

      CALL scat2dxg(xplot,yplot,nx,color)

      RETURN
      END
*
      SUBROUTINE xgscat3d(xplot,yplot,zplot,nx,color)
****************************************************************
*  Subroutine XGSCAT3D adds a 3-D scatter plot to the
*  previously initialized window under XGrafiX.
****************************************************************
      
*     Input Arguments:
        INTEGER color, nx
        REAL zplot(*), xplot(*), yplot(*)
      
****************************************************************

      CALL scat3dxg(xplot,yplot,zplot,nx,color)

      RETURN
      END
*
      SUBROUTINE xgsurf(xplot,yplot,zplot,nx,ny,nz1dim,
     +                  color)
****************************************************************
*  Subroutine XGSURF adds a 3-D surface plot to the
*  previously initialized window under XGrafiX.
****************************************************************
      
*     Input Arguments:
        INTEGER color, nx, ny, nz1dim
        REAL zplot(nz1dim,*), xplot(*), yplot(*)
      
****************************************************************

      CALL surfxg(xplot,yplot,zplot,nx,ny,nz1dim,color)

      RETURN
      END
*
      SUBROUTINE xgcont(xplot,yplot,zplot,nx,ny,nz1dim,
     +                  color)
****************************************************************
*  Subroutine XGCONT adds a 2-D contour plot to the
*  previously initialized window under XGrafiX.
****************************************************************
      
*     Input Arguments:
        INTEGER color, nx, ny, nz1dim
        REAL zplot(nz1dim,*), xplot(*), yplot(*)
      
****************************************************************

      CALL contxg(xplot,yplot,zplot,nx,ny,nz1dim,color)

      RETURN
      END
*
        FUNCTION strlennb(str)
****************************************************************
*  Function STRLENNB returns either the index of last
*  non-blank character in the string STR or 1.
****************************************************************

        INTEGER strlennb
        CHARACTER*(*) str

        strlennb = LEN(str)

 10     CONTINUE

	IF (str(strlennb:strlennb) .NE. " ") THEN
          RETURN
        ELSE
          strlennb = strlennb - 1
        ENDIF

	IF (strlennb .GT. 1) GOTO 10

	RETURN
	END
*
