#include "ibc.h"

field()
{
  register int i, m;
  float theta, temp;
  /****************************************/
  /* Calculate the space charge potential */
  
  xp[nc] = 0;
  yp[nc] = 0;
  theta = Wo*Wo*dt*dt;
  
  temp = 2+5.784/(Rb*Rb);
  for (i=nc; i>0; i--)
    {
      xp[i-1] = 1/(temp - xp[i]);
      yp[i-1] = (theta*Qn[i] + yp[i])*xp[i-1];
    }
  phi[0] = 0;
  for (i=0; i<= nc; i++)	phi[i+1] = xp[i]*phi[i] + yp[i];
  
  /***************************************/
  /* Calculate the total electric field  */  
  
  temp = Ec[nc];
  for (i=1; i<= nc; i++)	Ec[i] += SCcoup*(phi[i-1] - phi[i]);
  Ec[nc+1] = temp;
  
  /**************************************************/
  /* Calculate the electric field at each electron  */
  
  for (m=0; m<np; m++)
    {
      s  = pos[m] + 0.5;
      i  = s;
      x  = s - i;
      Eb[m] = (1 - x)*Ec[i] + x*Ec[i+1];
    }
}
