#include "ibc.h"

/***************************************************************/
/* Dumping the current state of the system into a binary file. */
/* Note: the binary file is written in the format used by IBM  */
/* and DEC compatible machines (low bytes followed by high     */
/* bytes). For this Dump() and Restore() call the functions    */
/* sun_read() and sun_write().                                   */

char Revision[]={'1','.','1','0'};

void Dump(filename)
char *filename;
{
  int i, j;
  float ftemp;
  FILE *DMPFile;
  
  if ((DMPFile = fopen(filename, "w")) == NULL)
  {
    puts("Dump: open failed");
    return;
  }

  XGWrite(Revision, 1, 4, DMPFile, "char");

  ftemp = t;
  XGWrite(&ftemp, 4, 1, DMPFile, "float");
  XGWrite(&np, 4, 1, DMPFile, "int");

  for (i=0; i<np; i++)
    {
      ftemp = pos[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
      ftemp = vel[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
    }
  for (i=0; i<ng; i++)
    {
      ftemp = FDr[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
      ftemp = phi[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
      ftemp = Vc[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
      ftemp = Ic[i];
      XGWrite(&ftemp, 4, 1, DMPFile, "float");
    }
  XGWrite(fe, 4, nbins, DMPFile, "float");
  fclose(DMPFile);
}

/****************************************************************/

void Restore(filename)
char *filename;
{
  char Rev[5];
  int i, j;
  float ftemp;
  FILE *DMPFile;
  
  if ((DMPFile = fopen(filename, "r+b")) == NULL)
  {
    puts("Dump: open failed");
    return;
  }

  XGRead(Rev, 1, 4, DMPFile, "char");
  for (i=0; i<4; i++)
    if (Rev[i]!=Revision[i])
    {
      puts("Incompatible dump file version");
      putchar(7);
      exit(1);
    }
  XGRead(&ftemp, 4, 1, DMPFile, "float");
  t = ftemp;
  XGRead(&np, 4, 1, DMPFile, "int");
  
  for (i=0; i<np; i++)
    {
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      pos[i] = ftemp;
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      vel[i]= ftemp;
    }

  for (i=0; i<ng; i++)
    {
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      FDr[i] = ftemp;
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      phi[i] = ftemp;
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      Vc[i]  = ftemp;
      XGRead(&ftemp, 4, 1, DMPFile, "float");
      Ic[i]  = ftemp;
    }
  XGRead(fe, 4, nbins, DMPFile, "float");
  fclose(DMPFile);
}

/****************************************************************/



