#include "ibc.h"

/****************************************************************/

InitWindows(argc, argv)
int argc;
char *argv[];
{
  int i, j;
  float temp;

  XGInit(argc, argv, &t);	

  /**************************************/
  /* Set up each window structure	*/

  XGSet2D("linlin", "Position (m)", "Vx-X Phase Space (m/s)", "iconic", 300, 10, 
	  dx, Vphase, False, True, 0.0, Length);

  XGScat2D(pos, vel, &np, 1);

/*********************************************/

  XGSet2D("linlin", "Position (m)", "Electron Density/Injected Density", "iconic",
	  600, 10, 1.0, 1.0, False, True, 0.0, Length);

  XGCurve(x_array, Qn_diag, &ng, 2);

/*********************************************/

  XGSet2D("linlin", "Position (m)", "Beam Current/Input Beam Current", "iconic",
	  60, 200, 1.0, 1.0, False, True, 0.0, Length);

  XGCurve(x_array, Ib, &ng, 3);

/********************************************/

  XGSet2D("linlin", "Position (m)", "Driving Term", "iconic",
	 260, 200, 1.0, 1.0, False, True, 0.0, Length);

  XGCurve(x_array, Dr, &ng, 4);

/********************************************/

  XGSet2D("linlin", "Position (m)", "Filtered Driving Term", "iconic",
	 560, 200, 1.0, 1.0, False, True, 0.0, Length);

  XGCurve(x_array, FDr, &ng, 5);

/********************************************/

  XGSet2D("linlin", "Position (m)", "Circuit Electric Field (V/m)", "iconic",
	 60, 400, 1.0, Vphase*Vphase/QeMe/dx, False, True, 0.0, Length);

  XGCurve(x_array, Ec, &ng, 6);

/************************************************/

  XGSet2D("linlin", "Position (m)", "Space Charge Field (V/m)", "iconic",
	 360, 400, 1.0, Vphase*Vphase/QeMe/dx, False, True, 0.0, Length);

  XGCurve(x_array, Es_diag, &ng, 7);

/************************************************/

  XGSet2D("linlin", "Position (m)", "Circuit Voltage (V)", "iconic",
	 660, 400, 1.0, Vphase*Vphase/QeMe, False, True, 0.0, Length);

  XGCurve(x_array, Vc, &ng, 0);

/************************************************/

  XGSet2D("linlin", "Position (m)", "Circuit Current (Amps)", "iconic",
	 60, 600, 1.0, Vphase*Vphase*Vphase*Ep0/QeMe, False, True, 0.0, Length);

  XGCurve(x_array, Iold, &ng, 1);

/**************************************************/

  XGSet2D("linlog", "Position (m)", "Circuit Power/Input Power", "iconic",
	 360, 600, 1.0, (Rin*C0+1)*(Rin*C0+1)/(Vo*Vo*C0), False, True, 0.0, Length);

  XGCurve(x_array, power, &ng, 2);

/**************************************************/

  XGSet2D("linlog", "Position (m)", "Circuit Power (Watts)", "iconic",
	 260, 500, 1.0, pow(Vphase, 5.0)*Ep0/QeMe/QeMe, False, True, 0.0, Length);

  XGCurve(x_array, power, &ng, 2);

/**************************************************/

  XGSet2D("linlin", "Position (m)", "Circuit Resistance (Ohms)", "iconic",
	 660, 600, 1.0, 1.0/(dx*Vphase*Ep0), False, True, 0.0, Length);

  XGCurve(x_array, Rc, &ng, 3);

/***************************************************/

  XGSet2D("linlin", "Energy (eV)", "f(E) at Collector", "iconic",
	 60, 60, 1.0, 1.0, False, True, emin, emax);

  XGCurve(e_array, fe, &nbins, 4);

}
/***************************************************/

Quit()
{
}
/***************************************************/
























