#include "ibc.h"

move()
{
  register int i, m;
  float temp1, temp2, temp3, energy;

  /* Move particles */
  for (m=0; m< np; m++)
    {
      vel[m] -= Eb[m];
      pos[m] += vel[m];
    }

  /* Absorb electrons which reach the collector */
  if (t<nc/vb)
    {
      m=0;
      while(m<np)
	{
	  if (pos[m] >= nc)
	    {
	      pos[m] = pos[--np];
	      vel[m] = vel[np];
	    }
	  else m++;
	}
    }
  if (t>=nc/vb)
    {
      m=0;
      while(m<np)
	{
	  if (pos[m] >= nc)
	    {
	      energy = (Escale*vel[m]*vel[m] - emin)/energy_interval;
	      i = energy;
	      if (i<nbins && i>=0)
		fe[i]++;
	      pos[m] = pos[--np];
	      vel[m] = vel[np];
	    }
	  else m++;
	}
    }

  /* Inject new beam electrons */
  Ein = (Ec[0] + Ec[1])/2;
	
  temp1= 1/nb;
  while(adde > 0)
    {
      vel[np] = vb - Ein*(adde - 0.5);
      pos[np] = vb*adde - Ein*adde*adde*0.5;
      np++;
      adde  -=	temp1;
    }
  adde += 1;

  /* Calculate the charge density of the beam, assume uniform distribution
     of immobile ions with density `ne' */

  for (i=0; i<= nc; i++)
    {
      Qo[i] = Qn[i];
      Qn[i] = ne;
    }
  for (m=0; m<np; m++){
    s  = pos[m];
    i  = s;
    x  = s - i;
    Qn[i]	-= 1 - x;
    Qn[i+1]	-= x;
  }
	
  for (i=0; i<= nc; i++) 	Qn[i] /= ne;
  Qn[0]  = 1e-10;
  Qn[nc] = Qo[nc-1];
					
  /* Calculate the beam current by summing the velocities per cell */
  temp1 = Ib[nc-1];	
  temp2 = Ib[nc];	
  for (i=2; i<nc; i++)	Ib[i] = 0;

  for (m=0; m<np; m++){
    s  = pos[m] - vel[m]*0.5 + 0.5;
    i  = s;
    x  = s - i;
    Ib[i]   += (1 - x )*vel[m];
    Ib[i+1] += x*vel[m];
  }

  temp3 = 1.0/(ne*vb);
  for (i=nc-1; i>1; i--)	Ib[i] *= temp3;
  Ib[0]		= 1;
  Ib[1]		= (Ib[0] + Ib[2])*0.5;
  Ib[nc]	= temp1;
  Ib[nc+1] = temp2;
}
